use xe2008r2
go

-- sqlclr, ucs, sqlserver (2nd guid - 655FD93F-3364-40D5-B2BA-330F7FFB6491) added
select * from sys.dm_xe_packages p

-- 259 rows affected
select * from xe2008r2.dbo.eventsr2
where [Full Name] like 'sqlserver.buffer%'

-- 449 rows affected in Denali
select * from xe2008r2.dbo.eventsden e 
where [Full Name] like 'sqlserver.buffer%'

-- in Denali, not in 2008r2
-- 255 rows affected
select * from xe2008r2.dbo.eventsden e 
where not exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
)
order by [Full Name]

-- in 2008r2, not in Denali
-- 65 rows affected
select * from xe2008r2.dbo.eventsr2 e2 
where not exists 
(select * from xe2008r2.dbo.eventsden e
 where e.[Full Name] = e2.[Full Name]
)
order by [Full Name]

-- events are the same, by name
-- 194 rows affected
select * from xe2008r2.dbo.eventsden e 
where exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
)

-- events are the same, by name
-- BUT packageid is not the same, for the new SQL Server package
-- 80 rows affected
select * from xe2008r2.dbo.eventsden e 
where exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
 and e.guid <> e2.guid
 and e.[Full Name] like 'sqlserver%' 
 and e2.[Full Name] like 'sqlserver%'
)
order by [Full Name]

-- events are the same, by name
-- and packageid IS the same, the old SQL Server package
-- 65 rows affected
select * from xe2008r2.dbo.eventsden e 
where exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
 and e.guid = e2.guid
 and e.[Full Name] like 'sqlserver%' 
 and e2.[Full Name] like 'sqlserver%'
)
order by [Full Name]

-- all events, past and present
select [Full Name], 'In Denali not in R2' as [Status], description
from xe2008r2.dbo.eventsden e 
where not exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
)
union all
select [Full Name], 'In R2 not in Denali', description 
from xe2008r2.dbo.eventsr2 e2 
where not exists 
(select * from xe2008r2.dbo.eventsden e
 where e.[Full Name] = e2.[Full Name]
)
union all
select [Full Name], 'In both Denali and R2', description 
from xe2008r2.dbo.eventsden e 
where exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
)
order by [Status], [Full Name]

-- which events are different?

-- the 1 package0 event is same
-- the 1 additional SecAudit event in Denali

-- 3 new packages
-- sqlclr package - 3 events
select p.name + '.' + o.name as [Full Name], 
       o.description 
from sys.dm_xe_objects o
join sys.dm_xe_packages p on o.package_guid = p.guid
where o.object_type = 'event'  
and p.name = 'sqlclr'
order by p.name, o.name

-- 21 rows
select p.name + '.' + o.name as [Full Name], 
       o.description 
from sys.dm_xe_objects o
join sys.dm_xe_packages p on o.package_guid = p.guid
where o.object_type = 'event'  
and p.name = 'ucs'
order by p.name, o.name

-- new sqlos, 8 rows
select * from xe2008r2.dbo.eventsden e 
where not exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
)
and e.[Full Name] like 'sqlos%'

-- sqlos events removed, 2 rows
select * from xe2008r2.dbo.eventsr2 e2 
where not exists 
(select * from xe2008r2.dbo.eventsden e
 where e.[Full Name] = e2.[Full Name]
)
and e2.[Full Name] like 'sqlos%'

-- contents of "new guid" sqlserver packages
select p.name + '.' + o.name as [Full Name], 
       o.description 
from sys.dm_xe_objects o
join sys.dm_xe_packages p on o.package_guid = p.guid
where o.object_type = 'event'  
and p.name = 'sqlserver' and p.guid = '03FDA7D0-91BA-45F8-9875-8B6DD0B8E9F2'
order by p.name, o.name

-- same named events moved to new sqlserver package
-- 80 rows
select * from xe2008r2.dbo.eventsden e 
where exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
)
and e.guid = '03FDA7D0-91BA-45F8-9875-8B6DD0B8E9F2'

-- old events kept in old package
select * from xe2008r2.dbo.eventsden e 
where exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
)
and e.guid = '655FD93F-3364-40D5-B2BA-330F7FFB6491'


-- service broker changes
-- broker - 15 rows
select * from xe2008r2.dbo.eventsden e 
where not exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
)
and e.[Full Name] LIKE '%broker%'

-- 46 broker events removed
select * from xe2008r2.dbo.eventsr2 e2 
where not exists 
(select * from xe2008r2.dbo.eventsden e
 where e.[Full Name] = e2.[Full Name]
)
and e2.[Full Name] LIKE '%broker%'

-- 28 events are the same
select * from xe2008r2.dbo.eventsden e 
where exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
)
and e.[Full Name] LIKE '%broker%'

-- "buffer" changes
-- buffer - 2 rows added in Denali
select * from xe2008r2.dbo.eventsden e 
where not exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
)
and e.[Full Name] LIKE 'sqlserver.buffer%'

-- 12 buffer events removed
select * from xe2008r2.dbo.eventsr2 e2 
where not exists 
(select * from xe2008r2.dbo.eventsden e
 where e.[Full Name] = e2.[Full Name]
)
and e2.[Full Name] LIKE 'sqlserver.buffer%'

-- 4 events are the same
select * from xe2008r2.dbo.eventsden e 
where exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
)
and e.[Full Name] LIKE 'sqlserver.buffer%'

-- besides broker and sqlserver.buffer events,
-- these events removed in Denali
/*
sqlos.worker_state_callback_executed - removed
sqlos.context_switch_callback_executed - removed
sqlserver.databases_data_file_size_changed - the next 2 both fire "database_file_size_change"
sqlserver.databases_log_file_size_changed
sqlserver.error_ring_buffer_recorded - security error ring buffer recorded ?
                                       connectivity ring buffer recorded ?
sqlserver.locks_lock_timeouts -> lock_timeouts
sqlserver.locks_lock_timeouts_greater_than_0 -> lock_timeouts_greater_than_0
*/

select * from xe2008r2.dbo.eventsden e 
where not exists 
(select * from xe2008r2.dbo.eventsr2 e2
 where e.[Full Name] = e2.[Full Name]
)
and e.[Full Name] LIKE 'sqlos%'


-- fields in sqlserver.error_reported
-- different than 2008R2
select p.name package_name, o.name event_name, c.name event_field, 
       c.type_name field_type, c.column_type column_type
from sys.dm_xe_objects o
join sys.dm_xe_packages p
      on o.package_guid = p.guid
join sys.dm_xe_object_columns c
      on o.name = c.object_name
where o.name = 'error_reported'